<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Entity;

use Sylius\Component\Core\Model\ProductVariantInterface;
use Sylius\Component\Product\Model\ProductInterface;
use Sylius\Component\Resource\Model\ResourceInterface;

interface QuoteItemInterface extends ResourceInterface
{
    public function getId(): ?int;

    public function getQuote(): ?QuoteInterface;

    public function setQuote(?QuoteInterface $quote): self;

    public function getVariant(): ?ProductVariantInterface;

    public function setVariant(?ProductVariantInterface $variant): self;

    public function getQuantity(): ?int;

    public function setQuantity(?int $quantity): self;

    public function getUnitPrice(): ?int;

    public function setUnitPrice(?int $unitPrice): self;

    public function getUnitTotal(): ?int;

    public function setUnitTotal(?int $unitTotal): self;

    public function getTotal(): ?int;

    public function setTotal(?int $total): self;

    public function getProductName(): ?string;

    public function setProductName(?string $productName): self;

    public function getVariantName(): ?string;

    public function setVariantName(?string $variantName): self;

    public function getProduct(): ProductInterface;

    public function equals(self $item): bool;
}
